#include <iostream>
#include "matrix.h"

using namespace std;

int main() {

    matrix a(4,4);
    a.randomize(10);

    matrix l = a.getLMatrix(), u = a.getUMatrix();
    matrix lu = l*u, luPS(a.getRowNo(),a.getColNo());

    cout <<"matrix A == " <<endl <<a <<endl;

    // permutate and rescale l*u back to obtain the initial matrix a
    for (unsigned int r=0; r<=a.getRowNo()-1; ++r)
        for (unsigned int c=0; c<=a.getRowNo()-1; ++c)
            luPS(a.getLUPermutationVector(r),c)
                = lu(r,c)/a.getLUScalingVector(a.getLUPermutationVector(r));

    cout <<"scaling vector == " <<endl <<a.getLUScalingVector() <<endl;
    cout <<"permutation vector == " <<endl <<a.getLUPermutationVector() <<endl;
    cout <<"matrix L == " <<endl <<l <<endl;
    cout <<"matrix U == " <<endl <<u <<endl;
    cout <<"matrix L*U == " <<endl <<lu <<endl;
    cout <<"permutated and back-scaled matrix L*U (luPS) == " <<endl <<luPS <<endl;
    cout <<"luPS == A ? " <<((luPS==a)?"YES":"NO") <<endl <<endl;
    cout <<"luPS - A ==" <<endl <<luPS+(-a) <<endl;

// uncomment the code below when solveLS() is ready
/*    matrix a1(4,4), b(4); 
    a1.randomize(10);
    b.randomize(10);
    
    matrix x = a1.solveLS(b);
    cout <<endl <<"---------------" <<endl <<endl;
    cout <<"A1 == " <<endl << a1 <<endl;
    cout <<"b == " <<endl << b <<endl;
    cout <<"x == " <<endl << x <<endl;
    cout <<"b - A1*x == " <<endl << b+(-a1*x) <<endl;
*/
    system("pause");    // for Dev-C++ users only
    return 0;
}
